*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
*
*		Any changes made to this file must be reflected in eaglerave.h

		IFND	EAGLERAVE
EAGLERAVE	SET	1

		include	include:exec/types.i
		include	"libraries/gadtools_lib.i"
		include	"libraries/gadtools.i"

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
*
*		Engine globals

	    STRUCTURE	EagleRave_Data,0;			/* RS-TABLE (TO BSS DATA) */
	       STRUCT	er_oRaveHost,rh_SIZEOF;			/* RaveHost data (struct RaveHost) */
	       STRUCT	er_oTimeReq,IOTV_SIZE;			/* Timerequest struct (struct timerequest) */
	       STRUCT	er_oEClockVal1,EV_SIZE;			/* EClockVal struct 1 (struct EClockVal) */
	       STRUCT	er_oEClockVal2,EV_SIZE;			/* EClockVal struct 2 (struct EClockVal) */
	       STRUCT	er_oEagleMsg,UM_SizeOf;			/* Msg to send to Eagleplayer */
		ULONG	er_oEPFlags;				/* Global EaglePlayer flags (ULONG) */
		 APTR	er_oUPSStruct;				/* User Program Structure ptr (APTR) */
		 APTR	er_oTimePort;				/* Ptr to timer.device msg port (struct MsgPort *) */
		 APTR	er_oMsgPort;				/* Eaglerave's messageport (struct MsgPort *) */
		 BYTE	er_oTimerOpen;				/* Timer device opened? (BYTE) */
		 BYTE	er_oNotifyEP;				/* Notify EP when quitting? (BYTE) */
		 BYTE	er_oSignal;				/* Engine's signal-bit (ULONG) */
		 BYTE	er_oPadByte;
		LABEL	er_SIZEOF;



		ENDC	;EAGLERAVE
